Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Canon.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Canon.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Canon.pm	(revision 34921)
@@ -5994,4 +8372,8 @@
     GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
     NOTES => 'This information is new in images from the EOS 7D.',
+    1 => {
+        Name => 'PeripheralIlluminationCorr',
+        PrintConv => \%offOn,
+    },
     2 => {
         Name => 'AutoLightingOptimizer',
@@ -6003,4 +8385,28 @@
         },
     },
+    3 => {
+        Name => 'HighlightTonePriority',
+        PrintConv => \%offOn,
+    },
+    4 => {
+        Name => 'LongExposureNoiseReduction',
+        PrintConv => {
+            0 => 'Off',
+            1 => 'Auto',
+            2 => 'On',
+        },
+    },
+    5 => {
+        Name => 'HighISONoiseReduction',
+        PrintConv => {
+            0 => 'Standard',
+            1 => 'Low',
+            2 => 'Strong',
+            3 => 'Off',
+        },
+    },
+    # 6 - related to ChromaticAberrationCorr
+    # 7 - related to DistortionCorrection (0=off, 1=On in a 5DmkIV sample)
+    # 8 - related to PeripheralIlluminationCorr and ChromaticAberrationCorr
 );
 
@@ -6010,5 +8416,5 @@
     FIRST_ENTRY => 0,
     GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
-    0 => { # this doesn't seem to be valid for some models (ie. 550D, 7D?, 1DmkIV?)
+    0 => { # this doesn't seem to be valid for some models (eg. 550D, 7D?, 1DmkIV?)
         Name => 'LensSerialNumber',
         Notes => q{
@@ -6016,8 +8422,9 @@
             to the one printed on the lens
         },
-        Condition => '$$valPt !~ /^\0\0\0\0/', # (rules out 550D and older lenses)
         Format => 'undef[5]',
+        Priority => 0,
+        RawConv => '$val=~/^\0\0\0\0/ ? undef : $val', # (rules out 550D and older lenses)
         ValueConv => 'unpack("H*", $val)',
-        ValueConvInv => 'pack("H*", $val)',
+        ValueConvInv => 'length($val) < 10 and $val = 0 x (10-length($val)) . $val; pack("H*",$val)',
     },
 );
@@ -6045,4 +8452,36 @@
 );
 
+# Multi-exposure information (MakerNotes tag 0x4021) (ref PH)
+%Image::ExifTool::Canon::MultiExp = (
+    %binaryDataAttrs,
+    FORMAT => 'int32s',
+    FIRST_ENTRY => 1,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Image' },
+    1 => {
+        Name => 'MultiExposure',
+        PrintConv => {
+            0 => 'Off',
+            1 => 'On',
+            2 => 'On (RAW)', #IB
+        },
+    },
+    2 => {
+        Name => 'MultiExposureControl',
+        PrintConv => {
+            0 => 'Additive',
+            1 => 'Average',
+            2 => 'Bright (comparative)',
+            3 => 'Dark (comparative)',
+        },
+    },
+    3 => 'MultiExposureShots',
+);
+
+my %filterConv = (
+    PrintConv => {
+        -1 => 'Off',
+        OTHER => sub { my $val=shift; return "On ($val)" },
+    },
+);
 # Creative filter information (MakerNotes tag 0x4024) (ref PH)
 %Image::ExifTool::Canon::FilterInfo = (
@@ -6053,23 +8492,10 @@
         Name => 'GrainyBWFilter',
         Description => 'Grainy B/W Filter',
-        PrintConv => '$val == -1 ? "Off" : "On ($val)"',
-        PrintConvInv => '$val =~ /([-+]?\d+)/ ? $1 : -1',
-    },
-    0x201 => {
-        Name => 'SoftFocusFilter',
-        PrintConv => '$val == -1 ? "Off" : "On ($val)"',
-        PrintConvInv => '$val =~ /([-+]?\d+)/ ? $1 : -1',
-    },
-    0x301 => {
-        Name => 'ToyCameraFilter',
-        PrintConv => '$val == -1 ? "Off" : "On ($val)"',
-        PrintConvInv => '$val =~ /([-+]?\d+)/ ? $1 : -1',
-    },
-    0x401 => {
-        Name => 'MiniatureFilter',
-        PrintConv => '$val == -1 ? "Off" : "On ($val)"',
-        PrintConvInv => '$val =~ /([-+]?\d+)/ ? $1 : -1',
-    },
-    0x0402 => {
+        %filterConv,
+    },
+    0x201 => { Name => 'SoftFocusFilter',   %filterConv },
+    0x301 => { Name => 'ToyCameraFilter',   %filterConv },
+    0x401 => { Name => 'MiniatureFilter',   %filterConv },
+    0x402 => {
         Name => 'MiniatureFilterOrientation',
         PrintConv => {
@@ -6078,19 +8504,434 @@
         },
     },
-    0x403=> 'MiniatureFilterPosition',
-    # 0x404 - value: 0, 345, 518, ... (miniature filter width maybe?)
-);
-
-# Canon CNTH atoms (ref PH)
+    0x403 => 'MiniatureFilterPosition',
+    0x404 => 'MiniatureFilterParameter', # but what is the meaning?
+    0x501 => { Name => 'FisheyeFilter',     %filterConv }, # (M2)
+    0x601 => { Name => 'PaintingFilter',    %filterConv }, # (M2)
+    0x701 => { Name => 'WatercolorFilter',  %filterConv }, # (M2)
+);
+
+# HDR information (MakerNotes tag 0x4025) (ref PH)
+%Image::ExifTool::Canon::HDRInfo = (
+    %binaryDataAttrs,
+    FORMAT => 'int32s',
+    FIRST_ENTRY => 1,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Image' },
+    1 => {
+        Name => 'HDR',
+        PrintConv => {
+            0 => 'Off',
+            1 => 'Auto',
+            2 => 'On',
+        },
+    },
+    2 => {
+        Name => 'HDREffect',
+        PrintConv => {
+            0 => 'Natural',
+            1 => 'Art (standard)',
+            2 => 'Art (vivid)',
+            3 => 'Art (bold)',
+            4 => 'Art (embossed)',
+        },
+    },
+    # 3 - maybe related to AutoImageAlign?
+);
+
+# AF configuration info (MakerNotes tag 0x4028) (ref PH)
+%Image::ExifTool::Canon::AFConfig = (
+    %binaryDataAttrs,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    FORMAT => 'int32s',
+    FIRST_ENTRY => 1,
+    1 => {
+        Name => 'AFConfigTool',
+        ValueConv => '$val + 1',
+        ValueConvInv => '$val - 1',
+        PrintConv => '"Case $val"',
+        PrintConvInv => '$val=~/(\d+)/ ? $1 : undef',
+    },
+    2 => 'AFTrackingSensitivity',
+    3 => {
+        Name => 'AFAccelDecelTracking',
+        Description => 'AF Accel/Decel Tracking',
+    },
+    4 => 'AFPointSwitching',
+    5 => { #52
+        Name => 'AIServoFirstImage',
+        PrintConv => {
+             0 => 'Equal Priority',
+             1 => 'Release Priority',
+             2 => 'Focus Priority',
+        },
+    },
+    6 => { #52
+        Name => 'AIServoSecondImage',
+        PrintConv => {
+             0 => 'Equal Priority',
+             1 => 'Release Priority',
+             2 => 'Focus Priority',
+             3 => 'Release High Priority',
+             4 => 'Focus High Priority',
+        },
+    },
+    7 => { #52
+        Name => 'USMLensElectronicMF',
+        PrintConv => {
+             0 => 'Enable After AF',
+             1 => 'Disable After AF',
+             2 => 'Disable in AF Mode',
+        },
+    },
+    8 => { #52
+        Name => 'AFAssistBeam',
+        PrintConv => {
+             0 => 'Enable',
+             1 => 'Disable',
+             2 => 'IR AF Assist Beam Only',
+        },
+    },
+    9 => { #52
+        Name => 'OneShotAFRelease',
+        PrintConv => {
+             0 => 'Focus Priority',
+             1 => 'Release Priority',
+        },
+    },
+    10 => { #52
+        Name => 'AutoAFPointSelEOSiTRAF',
+        Description => 'Auto AF Point Sel EOS iTR AF',
+        # valid for: 1DX, 1DXmkII, 7DmkII, 5DS, 5DSR
+        # not valid for: 5DmkIII
+        Notes => 'only valid for some models',
+        Condition => '$$self{Model} !~ /5D /',
+        PrintConv => {
+             0 => 'Enable',
+             1 => 'Disable',
+        },
+    },
+    11 => { #52
+        Name => 'LensDriveWhenAFImpossible',
+        PrintConv => {
+             0 => 'Continue Focus Search',
+             1 => 'Stop Focus Search',
+        },
+    },
+    12 => { #52
+        Name => 'SelectAFAreaSelectionMode',
+        PrintConv => { BITMASK => {
+            0 => 'Single-point AF',
+            1 => 'Auto', # (61 point)
+            2 => 'Zone AF',
+            3 => 'AF Point Expansion (4 point)',
+            4 => 'Spot AF',
+            5 => 'AF Point Expansion (8 point)',
+        }},
+    },
+    13 => { #52
+        Name => 'AFAreaSelectionMethod',
+        PrintConv => {
+             0 => 'M-Fn Button',
+             1 => 'Main Dial',
+        },
+    },
+    14 => { #52
+        Name => 'OrientationLinkedAF',
+        PrintConv => { # Covers both 1Dx (0-2) and 5D3 (0-1)
+             0 => 'Same for Vert/Horiz Points',
+             1 => 'Separate Vert/Horiz Points',
+             2 => 'Separate Area+Points',
+        },
+    },
+    15 => { #52
+        Name => 'ManualAFPointSelPattern',
+        PrintConv => {
+             0 => 'Stops at AF Area Edges',
+             1 => 'Continuous',
+        },
+    },
+    16 => { #52
+        Name => 'AFPointDisplayDuringFocus',
+        PrintConv => {
+             0 => 'Selected (constant)',
+             1 => 'All (constant)',
+             2 => 'Selected (pre-AF, focused)',
+             3 => 'Selected (focused)',
+             4 => 'Disabled',
+        },
+    },
+    17 => { #52
+        Name => 'VFDisplayIllumination',
+        PrintConv => {
+             0 => 'Auto',
+             1 => 'Enable',
+             2 => 'Disable',
+        },
+    },
+    18 => { #52
+        Name => 'AFStatusViewfinder',
+        Condition => '$$self{Model} =~ /1D X/',
+        Notes => '1D X only',
+        PrintConv => {
+             0 => 'Show in Field of View',
+             1 => 'Show Outside View',
+        },
+    },
+    19 => { #52
+        Name => 'InitialAFPointInServo',
+        Condition => '$$self{Model} =~ /1D X/',
+        Notes => '1D X only',
+        PrintConv => {
+             0 => 'Initial AF Point Selected',
+             1 => 'Manual AF Point',
+             2 => 'Auto', #PH (1DXmkII)
+        },
+    },
+);
+
+# RAW burst mode info (MakerNotes tag 0x403f) (ref 25)
+%Image::ExifTool::Canon::RawBurstInfo = (
+    %binaryDataAttrs,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    FORMAT => 'int32u',
+    FIRST_ENTRY => 1,
+    1 => 'RawBurstImageNum',
+    2 => 'RawBurstImageCount',
+);
+
+# Canon UUID atoms (ref PH, SX280)
+%Image::ExifTool::Canon::uuid = (
+    GROUPS => { 0 => 'MakerNotes', 1 => 'Canon', 2 => 'Video' },
+    WRITE_PROC => 'Image::ExifTool::QuickTime::WriteQuickTime',
+    NOTES => q{
+        Tags extracted from the uuid atom of MP4 videos from cameras such as the
+        SX280, and CR3 images from cameras such as the EOS M50.
+    },
+    CNCV => {
+        Name => 'CompressorVersion',
+        # use this to recognize the specific type of Canon RAW (CR3 or CRM)
+        RawConv => '$self->OverrideFileType($1) if $val =~ /^Canon(\w{3})/i; $val',
+    },
+    # CNDM - 4 bytes - 0xff,0xd8,0xff,0xd9
+    CNTH => {
+        Name => 'CanonCNTH',
+        SubDirectory => { TagTable => 'Image::ExifTool::Canon::CNTH' },
+    },
+    CCTP => { # (CR3 files)
+        Name => 'CanonCCTP',
+        SubDirectory => {
+            TagTable => 'Image::ExifTool::Canon::CCTP',
+            Start => '12',
+        },
+    },
+    # CTBO - (CR3 files) int32u entry count N, N x (int32u index, int64u offset, int64u size)
+    #        index: 1=XMP, 2=PRVW, 3=mdat, 4=?, 5=?
+    #        --> ignored when reading, but offsets are updated when writing
+    CMT1 => { # (CR3 files)
+        Name => 'IFD0',
+        SubDirectory => {
+            TagTable => 'Image::ExifTool::Exif::Main',
+            ProcessProc => \&Image::ExifTool::ProcessTIFF,
+            WriteProc => \&Image::ExifTool::WriteTIFF,
+        },
+    },
+    CMT2 => { # (CR3 files)
+        Name => 'ExifIFD',
+        SubDirectory => {
+            TagTable => 'Image::ExifTool::Exif::Main',
+            ProcessProc => \&Image::ExifTool::ProcessTIFF,
+            WriteProc => \&Image::ExifTool::WriteTIFF,
+        },
+    },
+    CMT3 => { # (CR3 files)
+        Name => 'MakerNoteCanon',
+        SubDirectory => {
+            TagTable => 'Image::ExifTool::Canon::Main',
+            ProcessProc => \&ProcessCMT3,
+            WriteProc => \&Image::ExifTool::WriteTIFF,
+        },
+    },
+    CMT4 => { # (CR3 files)
+        Name => 'GPSInfo',
+        SubDirectory => {
+            TagTable => 'Image::ExifTool::GPS::Main',
+            ProcessProc => \&Image::ExifTool::ProcessTIFF,
+            WriteProc => \&Image::ExifTool::WriteTIFF,
+            DirName => 'GPS',
+        },
+    },
+    THMB => {
+        Name => 'ThumbnailImage',
+        Groups => { 2 => 'Preview' },
+        RawConv => 'substr($val, 16)',
+        Binary => 1,
+    },
+    CNOP => { #PH (M50)
+        Name => 'CanonCNOP',
+        SubDirectory => { TagTable => 'Image::ExifTool::Canon::CNOP' },
+    },
+);
+
+# Canon top-level uuid atoms (ref PH, written by DPP4)
+%Image::ExifTool::Canon::uuid2 = (
+    WRITE_PROC => 'Image::ExifTool::QuickTime::WriteQuickTime',
+    CNOP => {
+        Name => 'CanonVRD',
+        SubDirectory => {
+            TagTable => 'Image::ExifTool::CanonVRD::Main',
+            WriteProc => 'Image::ExifTool::CanonVRD::WriteCanonDR4',
+        },
+    },
+);
+
+%Image::ExifTool::Canon::UnknownIFD = (
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+);
+
+# Canon CCTP atoms (ref PH, CR3 files)
+%Image::ExifTool::Canon::CCTP = (
+    GROUPS => { 0 => 'MakerNotes', 1 => 'Canon', 2 => 'Video' },
+    # CCDT - int32u[3]: 0. 0, 1. decoder type?, 2. 0, 3. index
+);
+
+# 'CMP1' atom information (ref 54, CR3 files)
+%Image::ExifTool::Canon::CMP1 = (
+    PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
+    GROUPS => { 0 => 'MakerNotes', 1 => 'Canon', 2 => 'Image' },
+    FORMAT => 'int16u',
+    FIRST_ENTRY => 0,
+    PRIORITY => 0,
+    8  => { Name => 'ImageWidth',  Format => 'int32u' },
+    10 => { Name => 'ImageHeight', Format => 'int32u' },
+    # (the rest of the documented tags don't seem to produced good values with my samples - PH)
+);
+
+# 'CDI1' atom information (ref PH, CR3 files)
+%Image::ExifTool::Canon::CDI1 = (
+    GROUPS => { 0 => 'MakerNotes', 1 => 'Canon', 2 => 'Image' },
+    IAD1 => { Name => 'IAD1', SubDirectory => { TagTable => 'Image::ExifTool::Canon::IAD1' } },
+);
+
+# 'IAD1' atom information (ref 54, CR3 files)
+%Image::ExifTool::Canon::IAD1 = (
+    PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
+    GROUPS => { 0 => 'MakerNotes', 1 => 'Canon', 2 => 'Image' },
+    FORMAT => 'int16u',
+    FIRST_ENTRY => 0,
+);
+
+# Canon Timed MetaData (ref PH, CR3 files)
+%Image::ExifTool::Canon::CTMD = (
+    GROUPS => { 0 => 'MakerNotes', 1 => 'Canon', 2 => 'Image' },
+    PROCESS_PROC => \&ProcessCTMD,
+    NOTES => q{
+        Canon Timed MetaData tags found in CR3 images.  The L<ExtractEmbedded|../ExifTool.html#ExtractEmbedded> option
+        is automatically applied when reading CR3 files to be able to extract this
+        information.
+    },
+    1 => {
+        Name => 'TimeStamp',
+        Groups => { 2 => 'Time' },
+        RawConv => q{
+            my $fmt = GetByteOrder() eq 'MM' ? 'x2nCCCCCC' : 'x2vCCCCCC';
+            sprintf('%.4d:%.2d:%.2d %.2d:%.2d:%.2d.%.2d', unpack($fmt, $val));
+        },
+        PrintConv => '$self->ConvertDateTime($val)',
+    },
+  # 3 - 4 bytes, seen: ff ff ff ff
+    4 => {
+        Name => 'FocalInfo',
+        SubDirectory => { TagTable => 'Image::ExifTool::Canon::FocalInfo' },
+    },
+    5 => {
+        Name => 'ExposureInfo',
+        SubDirectory => { TagTable => 'Image::ExifTool::Canon::ExposureInfo' },
+    },
+    7 => {
+        Name => 'ExifInfo7',
+        SubDirectory => { TagTable => 'Image::ExifTool::Canon::ExifInfo' },
+    },
+    8 => {
+        Name => 'ExifInfo8',
+        SubDirectory => { TagTable => 'Image::ExifTool::Canon::ExifInfo' },
+    },
+    9 => {
+        Name => 'ExifInfo9',
+        SubDirectory => { TagTable => 'Image::ExifTool::Canon::ExifInfo' },
+    },
+  # 10 - 60 bytes: all zeros with a pair of 0xff's at offset 0x02 (C200 CRM)
+  # 11 - 612 bytes: all zero with pairs of 0xff's at offset 0x6e and 0x116 (C200 CRM)
+);
+
+# Canon Timed MetaData (ref PH, CR3 files)
+%Image::ExifTool::Canon::ExifInfo = (
+    GROUPS => { 0 => 'MakerNotes', 1 => 'Canon', 2 => 'Image' },
+    PROCESS_PROC => \&ProcessExifInfo,
+    0x8769 => {
+        Name => 'ExifIFD',
+        SubDirectory => {
+            TagTable => 'Image::ExifTool::Exif::Main',
+            ProcessProc => \&Image::ExifTool::ProcessTIFF,
+        },
+    },
+    0x927c => {
+        Name => 'MakerNoteCanon',
+        SubDirectory => {
+            TagTable => 'Image::ExifTool::Canon::Main',
+            ProcessProc => \&Image::ExifTool::ProcessTIFF,
+        },
+    },
+);
+
+# timed focal length information (ref PH, CR3 files)
+%Image::ExifTool::Canon::FocalInfo = (
+    PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
+    GROUPS => { 0 => 'MakerNotes', 1 => 'Canon', 2 => 'Image' },
+    FORMAT => 'int32u',
+    FIRST_ENTRY => 0,
+    0 => {
+        Name => 'FocalLength',
+        Format => 'rational32u',
+        PrintConv => 'sprintf("%.1f mm",$val)',
+    },
+);
+
+# timed exposure information (ref PH, CR3 files)
+%Image::ExifTool::Canon::ExposureInfo = (
+    PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
+    GROUPS => { 0 => 'MakerNotes', 1 => 'Canon', 2 => 'Image' },
+    FORMAT => 'int32u',
+    FIRST_ENTRY => 0,
+    0 => {
+        Name => 'FNumber',
+        Format => 'rational32u',
+        PrintConv => 'Image::ExifTool::Exif::PrintFNumber($val)',
+    },
+    1 => {
+        Name => 'ExposureTime',
+        Format => 'rational32u',
+        PrintConv => 'Image::ExifTool::Exif::PrintExposureTime($val)',
+    },
+    2 => {
+        Name => 'ISO',
+        Format => 'int32u',
+        ValueConv => '$val & 0x7fffffff',   # (not sure what high bit indicates)
+    },
+);
+
 %Image::ExifTool::Canon::CNTH = (
     GROUPS => { 0 => 'MakerNotes', 1 => 'Canon', 2 => 'Video' },
+    VARS => { ATOM_COUNT => 1 },    # only one contained atom
+    WRITABLE => 1,
+    WRITE_PROC => 'Image::ExifTool::QuickTime::WriteQuickTime',
     NOTES => q{
-        Canon-specific QuickTime tags found in the CNTH atom of MOV videos from some
-        cameras such as the PowerShot S95.
+        Canon-specific QuickTime tags found in the CNTH atom of MOV/MP4 videos from
+        some cameras.
     },
     CNDA => {
         Name => 'ThumbnailImage',
+        Groups => { 2 => 'Preview' },
         Format => 'undef',
         Notes => 'the full THM image, embedded metadata is extracted as the first sub-document',
+        SetBase => 1,
         RawConv => q{
             $$self{DOC_NUM} = ++$$self{DOC_COUNT};
@@ -6099,5 +8940,21 @@
             return \$val;
         },
-    },
+        RawConvInv => '$val',
+    },
+);
+
+# Canon CNOP atoms (ref PH)
+%Image::ExifTool::Canon::CNOP = (
+    GROUPS => { 0 => 'MakerNotes', 1 => 'Canon', 2 => 'Video' },
+    # CNFB - 52 bytes (7DmkII,M50,C200)
+    # CNMI - 4 bytes: "0x20000001" (C200)
+    # CNCM - 48 bytes: original file name in bytes 24-31 (C200)
+);
+
+# 'skip' atom of Canon MOV videos (ref PH)
+%Image::ExifTool::Canon::Skip = (
+    GROUPS => { 0 => 'MakerNotes', 1 => 'Canon', 2 => 'Video' },
+    NOTES => 'Information found in the "skip" atom of Canon MOV videos.',
+    CNDB => { Name => 'Unknown_CNDB', Unknown => 1, Binary => 1 },
 );
 
@@ -6119,6 +8976,6 @@
     Lens => {
         Require => {
-            0 => 'ShortFocal',
-            1 => 'LongFocal',
+            0 => 'Canon:MinFocalLength',
+            1 => 'Canon:MaxFocalLength',
         },
         ValueConv => '$val[0]',
@@ -6128,6 +8985,6 @@
         Description => 'Lens',
         Require => {
-            0 => 'ShortFocal',
-            1 => 'LongFocal',
+            0 => 'Canon:MinFocalLength',
+            1 => 'Canon:MaxFocalLength',
             3 => 'Lens',
         },
@@ -6272,5 +9129,12 @@
             FileIndex => '$val=~/(\d+)-(\d+)/; $2',
         },
-        ValueConv => 'sprintf("%.3d-%.4d",@val)',
+        ValueConv => q{
+            # fix the funny things that these numbers do when they wrap over 9999
+            # (it seems that FileIndex and DirectoryIndex actually store the
+            #  numbers from the previous image, so we need special logic
+            #  to handle the FileIndex wrap properly)
+            $val[1] == 10000 and $val[1] = 1, ++$val[0];
+            return sprintf("%.3d-%.4d",@val);
+        },
     },
 );
@@ -6302,13 +9166,49 @@
 
 #------------------------------------------------------------------------------
+# Attempt to calculate sensor size for Canon cameras
+# Inputs: 0/1) rational values for FocalPlaneX/YResolution
+# Returns: Sensor diagonal size in mm, or undef
+# Notes: This algorithm is fairly reliable, but has been found to give incorrect
+#        values for some firmware versions of the EOS 20D, A310, SD40 and IXUS 65
+# (ref http://wyw.dcweb.cn/download.asp?path=&file=jhead-2.96-ccdwidth_hack.zip)
+sub CalcSensorDiag($$)
+{
+    my ($xres, $yres) = @_;
+    # most Canon cameras store the sensor size in the denominator
+    if ($xres and $yres) {
+        # assumptions: 1) numerators are image width/height * 1000
+        # 2) denominators are sensor width/height in inches * 1000
+        my @xres = split /[ \/]/, $xres;
+        my @yres = split /[ \/]/, $yres;
+        # verify assumptions as best we can:
+            # numerators are always divisible by 1000
+        if ($xres[0] % 1000 == 0 and $yres[0] % 1000 == 0 and
+            # at least 640x480 pixels (DC models - PH)
+            $xres[0] >= 640000 and $yres[0] >= 480000 and
+            # ... but not too big!
+            $xres[0] < 10000000 and $yres[0] < 10000000 and
+            # minimum sensor size is 0.061 inches (DC models - PH)
+            $xres[1] >= 61 and $xres[1] < 1500 and
+            $yres[1] >= 61 and $yres[1] < 1000 and
+            # sensor isn't square (may happen if rationals have been reduced)
+            $xres[1] != $yres[1])
+        {
+            return sqrt($xres[1]*$xres[1] + $yres[1]*$yres[1]) * 0.0254;
+        }
+    }
+    return undef;
+}
+
+#------------------------------------------------------------------------------
 # Attempt to identify the specific lens if multiple lenses have the same LensType
-# Inputs: 0) PrintConv hash ref, 1) LensType, 2) ShortFocal, 3) LongFocal
+# Inputs: 0) PrintConv hash ref, 1) LensType, 2) MinFocalLength, 3) MaxFocalLength
 #         4) MaxAperture, 5) LensModel
-# Notes: PrintConv, LensType, ShortFocal and LongFocal must be defined.
+# Notes: PrintConv, LensType, MinFocalLength and MaxFocalLength must be defined.
 #        Other inputs are optional.
 sub PrintLensID(@)
 {
     my ($printConv, $lensType, $shortFocal, $longFocal, $maxAperture, $lensModel) = @_;
-    my $lens = $$printConv{$lensType};
+    my $lens;
+    $lens = $$printConv{$lensType} unless $lensType eq '-1' or $lensType eq '65535';
     if ($lens) {
         # return this lens unless other lenses have the same LensType
@@ -6321,11 +9221,10 @@
             push @lenses, $$printConv{"$lensType.$i"};
         }
+        my ($tc, @user, @maybe, @likely, @matches);
         # look for lens in user-defined lenses
         foreach $lens (@lenses) {
-            next unless $Image::ExifTool::userLens{$lens};
-            return LensWithTC($lens, $shortFocal);
+            push @user, $lens if $Image::ExifTool::userLens{$lens};
         }
         # attempt to determine actual lens
-        my ($tc, @maybe, @likely, @matches);
         foreach $tc (1, 1.4, 2, 2.8) {  # loop through teleconverter scaling factors
             foreach $lens (@lenses) {
@@ -6336,4 +9235,9 @@
                 $lf = $sf if $sf and not $lf;
                 $la = $sa if $sa and not $la;
+                # account for converter-specific LensType's (ie. end with " + #.#x")
+                if ($lens =~ / \+ (\d+(\.\d+)?)x$/) {
+                    $sf *= $1;  $lf *= $1;
+                    $sa *= $1;  $la *= $1;
+                }
                 next if abs($shortFocal - $sf * $tc) > 0.9;
                 my $tclens = $lens;
@@ -6351,11 +9255,42 @@
             last if @maybe;
         }
+        if (@user) {
+            # choose the best match if we have more than one
+            if (@user > 1) {
+                my ($try, @good);
+                foreach $try (\@matches, \@likely, \@maybe) {
+                    foreach (@$try) {
+                        $Image::ExifTool::userLens{$_} and push(@good, $_), next;
+                        # check for match with TC string removed
+                        next unless /^(.*) \+ \d+(\.\d+)?x$/;
+                        $Image::ExifTool::userLens{$1} and push(@good, $_);
+                    }
+                    return join(' or ', @good) if @good;
+                }
+            }
+            # default to returning the first user-defined lens
+            return LensWithTC($user[0], $shortFocal);
+        }
+        # differentiate Sigma Art/Contemporary/Sports models
+        if (@matches > 1 and $lensModel and $lensModel =~ /(\| [ACS])/) {
+            my $type = $1;
+            my @best;
+            foreach $lens (@matches) {
+                push @best, $lens if $lens =~ /\Q$type/;
+            }
+            @matches = @best if @best;
+        }
+        @matches = @likely unless @matches;
+        @matches = @maybe unless @matches;
+        Image::ExifTool::Exif::MatchLensModel(\@matches, $lensModel);
         return join(' or ', @matches) if @matches;
-        return join(' or ', @likely) if @likely;
-        return join(' or ', @maybe) if @maybe;
     } elsif ($lensModel and $lensModel =~ /\d/) {
-        # use lens model as written by the camera (add "Canon" to the start
-        # since the camera only understands Canon lenses anyway)
-        return "Canon $lensModel";
+        # use lens model as written by the camera
+        if ($printConv eq \%canonLensTypes) {
+            # add "Canon" to the start since the Canon cameras only understand Canon lenses
+            return "Canon $lensModel";
+        } else {
+            return $lensModel;
+        }
     }
     my $str = '';
@@ -6365,5 +9300,6 @@
         $str .= 'mm';
     }
-    return "Unknown$str" if $lensType eq '-1'; # (careful because Sigma LensType's may not be integer)
+    # (careful because Sigma LensType's may not be integer, so use string comparison)
+    return "Unknown$str" if $lensType eq '-1' or $lensType eq '65535';
     return "Unknown ($lensType)$str";
 }
@@ -6432,8 +9368,8 @@
 sub ReadODD($$)
 {
-    my ($exifTool, $offset) = @_;
+    my ($et, $offset) = @_;
     return undef unless $offset;
     my ($raf, $buff, $buf2, $i, $warn);
-    return undef unless defined($raf = $$exifTool{RAF});
+    return undef unless defined($raf = $$et{RAF});
     # the data block is a variable length and starts with 0xffffffff
     # followed a 4-byte (int32u) version number
@@ -6513,6 +9449,6 @@
         SetByteOrder($oldOrder);
         unless ($err) {
-            if ($exifTool->Options('HtmlDump')) {
-                $exifTool->HDump($offset, length $buff, '[OriginalDecisionData]', undef);
+            if ($et->Options('HtmlDump')) {
+                $et->HDump($offset, length $buff, '[OriginalDecisionData]', undef);
             }
             $raf->Seek($pos, 0);    # restore original file position
@@ -6520,5 +9456,5 @@
         }
     }
-    $exifTool->Warn($warn || 'Invalid original decision data');
+    $et->Warn($warn || 'Invalid original decision data');
     $raf->Seek($pos, 0);    # restore original file position
     return undef;
@@ -6579,21 +9515,22 @@
 #        at 0, and the corresponding values must be contiguous in memory.
 #        "Unknown" tags must be used to skip padding or unknown values.
+# (does not yet extract Rational values)
 sub ProcessSerialData($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     my $dataPt = $$dirInfo{DataPt};
     my $offset = $$dirInfo{DirStart};
     my $size = $$dirInfo{DirLen};
     my $base = $$dirInfo{Base} || 0;
-    my $verbose = $exifTool->Options('Verbose');
+    my $verbose = $et->Options('Verbose');
     my $dataPos = $$dirInfo{DataPos} || 0;
 
     # temporarily set Unknown option so GetTagInfo() will return existing unknown tags
     # (require to maintain serial data synchronization)
-    my $unknown = $exifTool->Options(Unknown => 1);
+    my $unknown = $et->Options(Unknown => 1);
     # but disable unknown tag generation (because processing ends when we run out of tags)
-    $$exifTool{NO_UNKNOWN} = 1;
-
-    $verbose and $exifTool->VerboseDir('SerialData', undef, $size);
+    $$et{NO_UNKNOWN} = 1;
+
+    $verbose and $et->VerboseDir('SerialData', undef, $size);
 
     # get default format ('int8u' unless specified)
@@ -6603,5 +9540,5 @@
     my $pos = 0;
     for ($index=0; $$tagTablePtr{$index} and $pos <= $size; ++$index) {
-        my $tagInfo = $exifTool->GetTagInfo($tagTablePtr, $index) or last;
+        my $tagInfo = $et->GetTagInfo($tagTablePtr, $index) or last;
         my $format = $$tagInfo{Format};
         my $count = 1;
@@ -6626,5 +9563,5 @@
         last unless defined $val;
         if ($verbose) {
-            $exifTool->VerboseInfo($index, $tagInfo,
+            $et->VerboseInfo($index, $tagInfo,
                 Index  => $index,
                 Table  => $tagTablePtr,
@@ -6640,5 +9577,5 @@
         $val{$index} = $val;
         if ($$tagInfo{SubDirectory}) {
-            my $subTablePtr = GetTagTable($tagInfo->{SubDirectory}->{TagTable});
+            my $subTablePtr = GetTagTable($$tagInfo{SubDirectory}{TagTable});
             my %dirInfo = (
                 DataPt => \$val,
@@ -6647,13 +9584,13 @@
                 DirLen => length($val),
             );
-            $exifTool->ProcessDirectory(\%dirInfo, $subTablePtr);
+            $et->ProcessDirectory(\%dirInfo, $subTablePtr);
         } elsif (not $$tagInfo{Unknown} or $unknown) {
             # don't extract zero-length information
-            $exifTool->FoundTag($tagInfo, $val) if $count;
+            $et->FoundTag($tagInfo, $val) if $count;
         }
         $pos += $len;
     }
-    $exifTool->Options(Unknown => $unknown);    # restore Unknown option
-    delete $$exifTool{NO_UNKNOWN};
+    $et->Options(Unknown => $unknown);    # restore Unknown option
+    delete $$et{NO_UNKNOWN};
     return 1;
 }
@@ -6695,5 +9632,5 @@
         push @points, "$row$col" if shift @bits;
     }
-    $focusing or $focusing = ($focus eq 0xff) ? 'Auto' : sprintf('Unknown (0x%.2x)',$focus);
+    $focusing or $focusing = ($focus == 0xff) ? 'Auto' : sprintf('Unknown (0x%.2x)',$focus);
     return "$focusing (" . join(',',@points) . ')';
 }
@@ -6702,5 +9639,5 @@
 # Convert Canon hex-based EV (modulo 0x20) to real number
 # Inputs: 0) value to convert
-# ie) 0x00 -> 0
+# eg) 0x00 -> 0
 #     0x0c -> 0.33333
 #     0x10 -> 0.5
